﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Scribble
{
    public partial class Form1 : Form
    {
        private bool isDrawing = false;
        private Point prevPos;
        private Graphics g;
        private Pen p;
        public int thickness = 1;   // form2 대화상자에서 사용
        private Color c = Color.Red;

        public Form1()
        {
            InitializeComponent();
            g = this.CreateGraphics();
            p = new Pen(c, thickness);
        }

        // Mouse
        private void Form1_MouseDown(object sender, MouseEventArgs e)
        {
            prevPos = new Point(e.X, e.Y);
            isDrawing = true;
        }

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {
            if (isDrawing)
            {
                Point currPos = new Point(e.X, e.Y);
                g.DrawLine(p, prevPos, currPos);
            }
            prevPos = new Point(e.X, e.Y);

            // 상태바에 마우스위치 표시
            statusStrip1.Items[0].Text = "마우스위치: " + e.X + "," + e.Y;
        }

        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {
            isDrawing = false;
        }

        // Keyboard
        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Space)
            {
                g.Clear(Color.White);
            }
        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)27) // ESC-key to exit
            {
                this.Close();
                //Application.Exit();
            }
        }

        // Menu
        private void closeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            g.Clear(Color.White);
        }

        private void colorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                System.Diagnostics.Trace.WriteLine("Debug: Color=" + colorDialog1.Color);
                c = colorDialog1.Color;
                p.Dispose();
                p = new Pen(c, thickness);
            }
        }

        private void toolStripMenuItem1_Click(object sender, EventArgs e)
        {
            thickness = 1;
            p.Dispose();
            p = new Pen(c, thickness);
            // menu item checked
            this.toolStripMenuItem1.Checked = true;
            this.toolStripMenuItem2.Checked = false;
            this.toolStripMenuItem3.Checked = false;
            this.toolStripMenuItem4.Checked = false;
            this.toolStripMenuItem5.Checked = false;
            // toolbar combobox
            toolStripComboBox1.SelectedIndex = 0;
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            thickness = 2;
            p.Dispose();
            p = new Pen(c, thickness);
            // menu item checked
            this.toolStripMenuItem1.Checked = false;
            this.toolStripMenuItem2.Checked = true;
            this.toolStripMenuItem3.Checked = false;
            this.toolStripMenuItem4.Checked = false;
            this.toolStripMenuItem5.Checked = false;
            // toolbar combobox
            toolStripComboBox1.SelectedIndex = 1;
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            thickness = 3;
            p.Dispose();
            p = new Pen(c, thickness);
            // menu item checked
            this.toolStripMenuItem1.Checked = false;
            this.toolStripMenuItem2.Checked = false;
            this.toolStripMenuItem3.Checked = true;
            this.toolStripMenuItem4.Checked = false;
            this.toolStripMenuItem5.Checked = false;
            // toolbar combobox
            toolStripComboBox1.SelectedIndex = 2;
        }

        private void toolStripMenuItem4_Click(object sender, EventArgs e)
        {
            thickness = 4;
            p.Dispose();
            p = new Pen(c, thickness);
            // menu item checked
            this.toolStripMenuItem1.Checked = false;
            this.toolStripMenuItem2.Checked = false;
            this.toolStripMenuItem3.Checked = false;
            this.toolStripMenuItem4.Checked = true;
            this.toolStripMenuItem5.Checked = false;
            // toolbar combobox
            toolStripComboBox1.SelectedIndex = 3;
        }

        private void toolStripMenuItem5_Click(object sender, EventArgs e)
        {
            thickness = 5;
            p.Dispose();
            p = new Pen(c, thickness);

            // menu item checked
            this.toolStripMenuItem1.Checked = false;
            this.toolStripMenuItem2.Checked = false;
            this.toolStripMenuItem3.Checked = false;
            this.toolStripMenuItem4.Checked = false;
            this.toolStripMenuItem5.Checked = true;

            // toolbar combobox
            toolStripComboBox1.SelectedIndex = 4;
        }

        // ToolBar
        private void toolStripComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (toolStripComboBox1.SelectedIndex) 
            {
                case 0: thickness = 1; break;
                case 1: thickness = 2; break;
                case 2: thickness = 3; break;
                case 3: thickness = 4; break;
                case 4: thickness = 5; break;
            }
            p.Dispose();
            p = new Pen(c, thickness);

            // menu item checked
            this.toolStripMenuItem1.Checked = (thickness == 1) ? true : false;
            this.toolStripMenuItem2.Checked = (thickness == 2) ? true : false;
            this.toolStripMenuItem3.Checked = (thickness == 3) ? true : false;
            this.toolStripMenuItem4.Checked = (thickness == 4) ? true : false;
            this.toolStripMenuItem5.Checked = (thickness == 5) ? true : false;
        }

        // Context Menu
        private void popupColorToolStripMenuItem_Click(object sender, EventArgs e)
        {

        }

        private void popupThickness1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            thickness = 1;
            p.Dispose();
            p = new Pen(c, thickness);
        }

        private void popupThickness2ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            thickness = 2;
            p.Dispose();
            p = new Pen(c, thickness);
        }

        private void popupThickness3ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            thickness = 3;
            p.Dispose();
            p = new Pen(c, thickness);
        }

        private void popupThickness4ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            thickness = 4;
            p.Dispose();
            p = new Pen(c, thickness);
        }

        private void popupThickness5ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            thickness = 5;
            p.Dispose();
            p = new Pen(c, thickness);
        }

        private void statusStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
            StatusStrip statusStrip1 = (StatusStrip)sender;
            MessageBox.Show(e.ClickedItem.Text, "statusStrip1_ItemClicked");
        }

        private void thicknessToolStripButton_Click(object sender, EventArgs e)
        {
            Form2 form2 = new Form2();
            form2.Owner = this;
            form2.ShowDialog();
            if (form2.DialogResult == DialogResult.OK)
            {
                thickness = int.Parse(form2.numberTextBox1.Text);
                System.Diagnostics.Trace.WriteLine("Debug: THICKNESS=" + thickness);
                p.Dispose();
                p = new Pen(c, thickness);
                form2.Close();
            }
            form2 = null;
        }

    }
}
